#!/usr/bin/env python
#
#  14-value_relay.py  -  Relay values into and out of a network like
#                        interactors do.  This is leading up to
#                        implementing our own DXUI.
#

import sys, os, time, DX

dxl_value = 0

def DXValueHandler( conn, name, value ):
  global dxl_value
  print "DX: %s is %s" % ( name, value )
  dxl_value = int( value )

def CreateNet( conn ):
  DX.exDXLBeginMacroDefinition( conn, 'macro main()' )
  DX.DXLSend( conn, "DXLOutput( \"value\", somevalue );" )
  DX.exDXLEndMacroDefinition( conn )
  DX.DXLSend( conn, "somevalue = %d;" % 0 )
  print "--> Setting new value to %d" % 0
  DX.DXLSetValueHandler( conn, "value", DXValueHandler )
  
def IncrementValue( conn ):
  DX.WaitForDXIdle  ( conn )
  print "--> Setting new value to %d" % (dxl_value+1)
  DX.DXLSend( conn, "somevalue = %d;" % (dxl_value+1) )


if __name__ == "__main__":
  conn = DX.DXLStartDX( DX.DXEXEC + " -execonly", None )
  CreateNet( conn )
  DX.DXLExecuteOnce( conn )

  for i in range(10):
    IncrementValue( conn )
    DX.DXLExecuteOnce( conn )

  DX.WaitForDXIdle  ( conn )
  DX.DXLRemoveValueHandler( conn, "value" )
  DX.DXLExitDX      ( conn )
